require "spymaster/version"
require 'net/http'

module Spymaster
@@app_name = nil, @@app_version = nil, @@uri = 'http://localhost:3000/global/track'

	# => Setup config settings
	def self.setup(t_app_name = nil, t_app_version = nil, t_uri = 'http://localhost:3000/global/track')
		@@app_name = t_app_name
		@@app_version = t_app_version
		@@uri = t_uri
		puts("Init Spymaster success" + @@app_name + @@app_version)
	end

	# => Get app name
	def self.app_name
		return @@app_name
	end

	# => Get app version
	def self.app_version
		return @@app_version
	end	

	# => Get uri
	def self.uri
		return @@uri
	end

	# => Send tracking
	def self.track(params = {})
		uri = URI(@@uri)
		fields_hash_type = ['platform', 'device', 'browser', 'extras']
		params.each do |field, value|
			value_convert = (fields_hash_type.include? field.to_s) ? self.check_validate(field, value, Hash) : value
			params[field] = value_convert
		end
		params = {
			:app_name => @@app_name, 
			:app_version => @@app_version
		}.merge(params)

		uri.query = URI.encode_www_form(params)

		res = Net::HTTP.get_response(uri)		
		if res.is_a?(Net::HTTPSuccess)
			return {
				:status => res.code,
				:response => res.body
			} 
		else
			return {
				:status => res.code
			}
		end
	end

	# => Check validate value
	def self.check_validate(field, value, class_type)
		return if value == nil
		if (value.class == class_type)
			puts("true")
			return value.to_json
		else
			puts(self.alert_validate_fail(field))
			return {}.to_json
		end
	end

	# => Alert when invalidate
	def self.alert_validate_fail(field = nil)
		return "Invalidate param #{field}"
	end
end
